/***************************************************************************
                          automateclass.cpp  -  description
                             -------------------
    begin                : Mon Sep 15 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "automateclass.h"
#include <qcheckbox.h>
#include <qlineedit.h>

AutomateClass::AutomateClass(QWidget *parent, const char *name ) : AutomateDlg(parent,name) {
}
AutomateClass::~AutomateClass(){
}
/** Checks all checkboxes for the logic between them */
void AutomateClass::slotCheck(){
  // Check for no gap.
  // if transcode and vcd is checked, mplex must also be checked e.g.
  if ( checkBoxTranscode->isChecked() && checkBoxVCD->isChecked() ){
    checkBoxMplex->setChecked(true); }
  if( checkBoxMplex->isChecked() && checkBoxCD->isChecked() ) {
    checkBoxVCD->setChecked(true); }
  if ( checkBoxTranscode->isChecked() && checkBoxCD->isChecked() ) {
    checkBoxMplex->setChecked(true); 
    checkBoxVCD->setChecked(true); 
  }
  // Sub-Checkboxes
  checkBoxMplexDelete->setEnabled( checkBoxMplex->isChecked() );
  checkBoxVCDDelete->setEnabled( checkBoxVCD->isChecked() );
  lineEditVCD->setEnabled(checkBoxVCD->isChecked() );
  checkBoxCDDelete->setEnabled( checkBoxCD->isChecked() );
}
/** Sets all the data in the Dialog */
void AutomateClass::setData(automateData s){
  checkBoxTranscode->setChecked(s.transcode);
  checkBoxMplex->setChecked(s.mplex);
  checkBoxVCD->setChecked(s.vcd);
  checkBoxCD->setChecked(s.cdr);
  checkBoxMplexDelete->setChecked(s.mplexDelete);
  checkBoxVCDDelete->setChecked(s.vcdDelete);
  checkBoxCDDelete->setChecked(s.cdrDelete);
  lineEditVCD->setText(s.filename);
}
/** Returns the structure of the data, contents of the dialog box */
void AutomateClass::getData(automateData &s){
  s.transcode=checkBoxTranscode->isChecked();
  s.mplex=checkBoxMplex->isChecked();
  s.vcd=checkBoxVCD->isChecked();
  s.cdr=checkBoxCD->isChecked();
  s.mplexDelete=checkBoxMplexDelete->isChecked();
  s.vcdDelete=checkBoxVCDDelete->isChecked();
  s.cdrDelete=checkBoxCDDelete->isChecked();
  s.filename=lineEditVCD->text();
}
