/***************************************************************************
                          automateclass.h  -  description
                             -------------------
    begin                : Mon Sep 15 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AUTOMATECLASS_H
#define AUTOMATECLASS_H

#include <qwidget.h>
#include "automatedlg.h"

/**Class for choosing all the processes that shall be automated
 *@author Cornelius Klbel
 */

class AutomateClass : public AutomateDlg  {
  Q_OBJECT
    public: 
  AutomateClass(QWidget *parent=0, const char *name=0);
  ~AutomateClass();
  /** data structure */
  struct automateData {
    bool runIt;
    bool transcode,mplex,vcd,cdr;
    bool mplexDelete,vcdDelete,cdrDelete;
    QString filename;
  };
  /** Sets all the data in the Dialog */
  void setData(automateData s);
  /** Returns the structure of the data, contents of the dialog box */
  void getData(automateData &s);
  private slots: // Private slots
    /** Checks all checkboxes for the logic between them */
    void slotCheck();
};

#endif
