/***************************************************************************
                          batchclass.cpp  -  description
                             -------------------
    begin                : Die Dez 2 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "batchclass.h"

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qstringlist.h>
#include <qtable.h>
#include <qpopupmenu.h>

BatchClass::BatchClass(QWidget *parent, const char *name ) : batchDlg(parent,name) {
  QStringList names;
  names.append("Video");
  names.append("Audio 1");
  names.append("Audio 2");
  tableFile->setColumnLabels(names);
  tableFile->hideColumn(1);
  tableFile->hideColumn(2);
  tableFile->setColumnWidth(0, 300);
  tableFile->setColumnWidth(1, 300);
  tableFile->setColumnWidth(2, 300);

}
BatchClass::~BatchClass(){
}
/** sets the Listof input files */
void BatchClass::setData(int spalte, QStringList list){
  //		tableFile->insertStringList(list);
  int row=-1;
  tableFile->showColumn(spalte);
  QStringList::Iterator it;
  for ( it = list.begin(); it != list.end(); ++it ) {
    row++;
    if (row+1 >  tableFile->numRows() ) { tableFile->setNumRows(row+1); }
    tableFile->setText( row, spalte, (*it));
    tableFile->setRowStretchable(row,false);
  }
  tableFile->adjustColumn(spalte);
}
/** Deletes the selected Files */
void BatchClass::slotDelete(){
  int cur=tableFile->currentRow();
  if ( cur != -1 ) {
    tableFile->removeRow(cur);
  }
}
/** Returns the modified stringlist of the input files */
QStringList BatchClass::getData(int spalte){
  QStringList list;
  for (int i=0; i<tableFile->numRows(); i++) {
    list.append( tableFile->text(i, spalte) );
  }
  return list;
}
/** This slot is called in case of contex menu  */
void BatchClass::tableFile_contextMenuRequested(int x, int y, const QPoint& point){
  myX=x; myY=y;
  QPopupMenu* myCMenu= new QPopupMenu(this);
  myCMenu->insertItem(i18n("Move cell &up"), this, SLOT(slotMoveUp()));
  myCMenu->insertItem(i18n("Move cell &down"), this, SLOT(slotMoveDown()));
  myCMenu->insertSeparator();
  myCMenu->insertItem(i18n("Delete cell"), this, SLOT(slotDeleteCell()) );
  myCMenu->exec(point);
  delete myCMenu;
}
/** Delete the cell row=x, column=y */
void BatchClass::slotDeleteCell(){
  tableFile->clearCell(myX,myY);
  for (int i = myX; i<tableFile->numRows(); i++) {
    tableFile->setText(i,myY, tableFile->text(i+1, myY));
  }
  int letzte=tableFile->numRows()-1;
  tableFile->clearCell(letzte,myY);
  if ( (tableFile->text(letzte,0).isEmpty()) &&
       (tableFile->text(letzte,1).isEmpty()) &&
       (tableFile->text(letzte,2).isEmpty()) ) {
    tableFile->removeRow(letzte);
  }
}
/** moves the current selection up */
void BatchClass::slotMoveUp(){
  if (myX > 0) {
    QString h=tableFile->text(myX,myY);
    tableFile->setText(myX  ,myY, tableFile->text(myX-1,myY));
    tableFile->setText(myX-1,myY, h);
    // This does not work. Needs redraw
    //tableFile->swapCells(myX,myY,myX-1,myY);
  }

}
/** Moves the current selection down */
void BatchClass::slotMoveDown(){
  if (myX < tableFile->numRows()-1 ) {
    QString h=tableFile->text(myX,myY);
    tableFile->setText(myX  ,myY, tableFile->text(myX+1,myY));
    tableFile->setText(myX+1,myY, h);
  }
}
