/***************************************************************************
                          batchclass.h  -  description
                             -------------------
    begin                : Die Dez 2 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BATCHCLASS_H
#define BATCHCLASS_H

#include <qwidget.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qpopupmenu.h>
#include <klocale.h>
#include "batchdlg.h"

/**The dialog for entering the batch numbers
 *@author Cornelius Klbel
 */

class BatchClass : public batchDlg  {
  Q_OBJECT
    public: 
  BatchClass(QWidget *parent=0, const char *name=0);
  ~BatchClass();
  /** Returns the modified stringlist of the input files */
  QStringList getData(int spalte);
  /** sets the list of input files */
  void setData(int spalte, QStringList list);
  protected slots: // Protected slots
    /** Deletes the selected Files */
    void slotDelete();
  /** This slot is called in case of contex menu  */
  void tableFile_contextMenuRequested(int x, int y, const QPoint& point);
  private slots: // Private slots
    /** Delete the cell row=x, column=y */
    void slotDeleteCell();
  /** Moves the current selection down */
  void slotMoveDown();
  /** moves the current slot up */
  void slotMoveUp();
 private: // Private attributes
  /** Position (Cell) of the contextmenu */
  int myX, myY;
  /** Context Menu */
  QPopupMenu* myCMenu;
};

#endif
/** sets the Listof input files */

