/***************************************************************************
                          cdrclass.h  -  description
                             -------------------
    begin                : Fre Jul 26 2002
    copyright            : (C) 2002 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDRCLASS_H
#define CDRCLASS_H

#include <qwidget.h>
#include <klocale.h>
#include "procbaseclass.h"

/**Klasse, die den Brennprozess enth�t.
 *@author Cornelius K�bel
 */

class CDRclass : public ProcBaseClass  {
  Q_OBJECT
    public: 
  CDRclass(QWidget *parent=0, const char *name=0);
  ~CDRclass();
  struct cdrData {
    QString additionalOption;
    QString device;
    QString driver;
    QString speed;
    bool eject;
    bool overburn;
    bool simulate;
    bool cdrw;
    QString cueFile;
    QString command;
    int nice;
    int cdrType;
  };
  /** Wertet den Fortschritt vom CD-Brennen aus. */
  static int progress(QString sAusgabe);
  /** �erl�t die Funktion der Basisklasse ProcBaseClass.
      Denn hier wird die Ausgabe von cdrdao ausgewertet. */
  void slotReadFromStdout(KProcess * proc, char * buffer, int buflen);
  void slotReadFromStderr(KProcess * proc, char * buffer, int buflen);
  /** Gets the progress (MB written) from the cdrecord output */
  static int progressCDRecord(QString sAusgabe);
  /** use cdrdao or cdrecord */
  void setCDRType(int i);
  /** set the GUI data */
  void setData(cdrData d);
  /** generates the kommando from the internal data and returns the string */
  QString generateKommando();
  /** start the process */
  bool start();
  /** Sets the number of the CDs to be burned in automate mode */
  void setNum(int i, int t);
 private: // Private attributes
  /** wether cdrdao=1 oder cdrecord=2 is used. */
  int myCDRType;
  /** Holds the GUI data */
  cdrData myData;
  protected slots: // Protected slots
    /** No descriptions */
    void slotCancel();
};

#endif
