/***************************************************************************
                          cdrwclass.cpp  -  description
                             -------------------
    begin                : Fre Apr 11 2003
    copyright            : (C) 2003 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cdrwclass.h"
#include <qtextedit.h>
#include <qlabel.h>

CDRWclass::CDRWclass(QWidget *parent, const char *name ) : ProcBaseClass(parent,name) {
  setCaption(i18n("blanking CDRW"));
  myErrorString=i18n("Error starting the CDRW blanking process.");
  PushButtonPreview->hide();
  TextLabelProgress->hide();
  TextLabelTime->setText(i18n("Blanking CDRW...."));
  TextLabelFrames->hide();
  TextLabelFrames2->hide();
  connect( myProc, SIGNAL(processExited()), this, SLOT(slotFinished()) );
  this->resize( QSize( 350,270) );
}
CDRWclass::~CDRWclass(){
}
/** Overload of ProcBaseClass. Plots the output */
void CDRWclass::slotReadFromStdout(KProcess * proc, char * buffer, int buflen){
  QString sAusgabe=QString(buffer);
  TextEditOutput->append(sAusgabe);
}
/** Overload of ProcBaseClass. Plots the output */
void CDRWclass::slotReadFromStderr(KProcess * proc, char * buffer, int buflen){
  QString sAusgabe=QString(buffer);
  TextEditOutput->append(sAusgabe);
}
/** Called when the process exited. */
void CDRWclass::slotFinished(){
  if ( !myProc->normalExit() ) {
    TextLabelTime->setText(i18n("Some Error occured!"));
  }
  PushButtonOK->show();
}
