/***************************************************************************
                          contextmenu.cpp  -  description
                             -------------------
    begin                : Sam Apr 19 2003
    copyright            : (C) 2003 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "contextmenu.h"
#include <qcombobox.h>
#include <qprocess.h>
#include <qmessagebox.h>

ContextMenu::ContextMenu(int tabIndex, QWidget *parent, const char *name ) : QPopupMenu(parent,name) {
  // Depending on the index (tab), different Menu entries are visible.
  myTabIndex = tabIndex;
  this->setCheckable( true );
  if ( myTabIndex==0 ) {
    myCheckINT = insertItem( i18n("In&terlace"), parent, SLOT(slotInterlace()), CTRL+Key_T);
    myCheckRAN = insertItem( i18n("&Range of frames"), parent, SLOT(slotRangeOfFrames()), CTRL+Key_R);
    myCheckDIR = insertItem( i18n("Directory &mode"), parent, SLOT(slotDirectoryMode()), CTRL+Key_M);
    myCheckSUB = insertItem( i18n("&Subtitler"), parent, SLOT(slotSubtitler()), CTRL+Key_S);
    //		myCheckASR = insertItem( i18n("&Keep aspect ratio"), parent, SLOT(slotChangeASR()), CTRL+Key_K);
    myCheckIEA = insertItem( i18n("&Aspect Ratio"), parent, SLOT(slotASR()), CTRL+Key_A);
    myCheckFPS = insertItem( i18n("&Frames per second"), parent, SLOT(slotFPS()), CTRL+Key_F);
    insertSeparator();
    insertItem( i18n("File&info for the input file"), parent, SLOT(slotShowFileInfo()), CTRL+Key_I);
    insertSeparator();
  }
  if ( myTabIndex==1 ) {
    insertItem( i18n("Batch mode"), parent, SLOT(slotShowBatch()) );
    insertSeparator();
    insertItem( i18n("&Generate/show Script"), parent, SLOT(slotGenerateScript()), CTRL+Key_G);
    insertSeparator();
  }
  switch (myTabIndex) {
  case 0:insertItem( i18n("&Manpage transcode"), this, SLOT(slotStartManpage()) );break;
  case 1:insertItem( i18n("&Manpage mplex"), this, SLOT(slotStartManpage()) );break;
  case 2:insertItem( i18n("&Manpage vcdimager"), this, SLOT(slotStartManpage()) );break;
  case 3:insertItem( i18n("&Manpage cdrdao"), this, SLOT(slotStartManpage()) );
    insertItem( i18n("Manpage cd&record"), this, SLOT(slotStartManpageCDRecord()) );
    insertSeparator();
    insertItem( i18n("&View CUE-File"),parent, SLOT(slotViewCue()), CTRL+Key_V );
    break;
				 
  } // end of switch
  insertSeparator();
  insertItem( i18n("&Preferences"),  parent, SLOT(slotPreferences()), CTRL+Key_P );
  insertItem( i18n("What's &This"), parent , SLOT(whatsThis()), SHIFT+Key_F1);
}

ContextMenu::~ContextMenu(){
}
/** Sets the aspect ration. Wether the menu entry is checked or not */
void ContextMenu::setAspectRatio(bool asr){
  setItemChecked( myCheckASR, asr );
}
/** check the menu entry Dirmode. */
void ContextMenu::setDirMode(bool b){
  setItemChecked( myCheckDIR, b );
}
/** checks menu entry interlace */
void ContextMenu::setInterlace(bool b){
  setItemChecked( myCheckINT, b );
}
/** checks the menu entry range of frames */
void ContextMenu::setRangeofFrames(bool b){
  setItemChecked( myCheckRAN, b );
}
/** checks the menu entry subtitles. */
void ContextMenu::setSubtitle(bool b){
  setItemChecked( myCheckSUB, b );
}
/** Starts the konquror with a mangape
 */
void ContextMenu::slotStartManpage(){
  // iProg = 0..3
  QProcess* proc = new QProcess( this );
  proc->addArgument( "konqueror" );
  switch (myTabIndex) {
  case 0: proc->addArgument("man:transcode"); break;
  case 1: proc->addArgument("man:mplex"); break;
  case 2: proc->addArgument("man:vcdimager"); break;
  case 3: proc->addArgument("man:cdrdao"); break;
  }
  if ( !proc->start() ) {
    // error handling
  }
}
/** starts the manpage of cdrecord */
void ContextMenu::slotStartManpageCDRecord(){
  QProcess* proc = new QProcess( this );
  proc->addArgument( "konqueror" );
  proc->addArgument("man:cdrecord"); 
  if ( !proc->start() ) {
    // error handling
  }
}

/** Sets the checkbox in front of asr in context menu */
void ContextMenu::setASR(bool b){
  setItemChecked( myCheckIEA, b );
}

void ContextMenu::setFPS(bool b){
 setItemChecked(myCheckFPS, b);
}
