/***************************************************************************
                          contextmenu.h  -  description
                             -------------------
    begin                : Sam Apr 19 2003
    copyright            : (C) 2003 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef CONTEXTMENU_H
#define CONTEXTMENU_H

#include <klocale.h>
#include <qwidget.h>
#include <qpopupmenu.h>
#include <qprocess.h>

#include "kavi2svcd.h"

/**The contextmenu for kavi2svcd class
 *@author Cornelius K�bel
 */

class ContextMenu : public QPopupMenu  {
  Q_OBJECT
    public: 
  ContextMenu(int tabIndex, QWidget *parent=0, const char *name=0);
  ~ContextMenu();
  /** Sets the aspect ration. Wether the menu entry is checked or not */
  void setAspectRatio(bool asr);
  /** check the menu entry Dirmode. */
  void setDirMode(bool b);
  /** checks the menu entry subtitles. */
  void setSubtitle(bool b);
  /** checks the menu entry range of frames */
  void setRangeofFrames(bool b);
  /** checks menu entry interlace */
  void setInterlace(bool b);
  /** Sets the checkbox in front of asr in context menu */
  void setASR(bool b);
  void setFPS(bool b);
 private: // Private attributes
  /** The index of the tab, the context menu was called from */
  int myTabIndex;
  /** stores the id of keep aspect ratio menu entry */
  int myCheckASR, myCheckINT, myCheckRAN, myCheckDIR, myCheckSUB, myCheckIEA, myCheckFPS;
  public slots: // Public slots
    /** Starts the konquror with a mangape */
    void slotStartManpage();
  private slots: // Private slots
    /** starts the manpage of cdrecord */
    void slotStartManpageCDRecord();

};

#endif
