/***************************************************************************
                          directorymodeclass.cpp  -  description
                             -------------------
    begin                : Don Aug 28 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "directorymodeclass.h"

#include <qcheckbox.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>

/**
   directory mode:
   --dir_mode base
   process directory contents to base-%03d.avi [off]

*/
DirectoryModeClass::DirectoryModeClass(QWidget *parent, const char *name ) : DirectoryModeDlg(parent,name) {
  // Initialization
  slotCheckDirMode();
  slotRadio();
}
DirectoryModeClass::~DirectoryModeClass(){
}
/** When the checkbox is checked. */
void DirectoryModeClass::slotCheckDirMode(){
  ButtonGroupDir->setEnabled( CheckBoxDirMode->isChecked() );
}
/** sets the basename for the directory mode */
void DirectoryModeClass::setBasename(QString b){
  LineEditBasename->setText( b );
}
/** Sets the filename, that was chosen. */
void DirectoryModeClass::setFilename(QString f){
  LineEditFilename->setText( f );
  // extract the basename from the filename.
  // cut "-XXX.avi" from the end.
  f=f.left( f.length()-8 );
  f=f.right( f.length()-f.findRev("/")-1 );
  LineEditBasename->setText( f );
}
/** sets wether the directory mode is active or not */
void DirectoryModeClass::setDirMode(bool d){
  CheckBoxDirMode->setChecked( d );
  slotCheckDirMode();
}
/** returns true, if the directorymode is activated */
bool DirectoryModeClass::getDirMode(){
  return CheckBoxDirMode->isChecked();
}
/** returns the basename of the files. */
QString DirectoryModeClass::getBasename(){
  return LineEditBasename->text();
}
/** Radiobutton import / option */
void DirectoryModeClass::slotRadio(){
  LineEditBasename->setEnabled(RadioButtonOption->isChecked() );
  CheckBoxNoSplit->setEnabled(RadioButtonOption->isChecked() );
}
/** Gets the Dirmode Type: Either OPTION or IMPORT */
int DirectoryModeClass::getDirModeType(){
  int rValue;
  rValue=-1;
  if ( RadioButtonOption->isChecked() ) rValue=OPTION;
  if ( RadioButtonImport->isChecked() ) rValue=IMPORT;
  return rValue;
}
/** Returns wether the option --no_split is set or not */
bool DirectoryModeClass::getNoSplit(){
  return CheckBoxNoSplit->isChecked();
}
/** sets the type wether: IMPORT or OPTION */
void DirectoryModeClass::setDirModeType(int t){
  if (t == IMPORT) RadioButtonImport->setChecked(true);
  if (t == OPTION) RadioButtonOption->setChecked(true);
}
/** Sets the checkbox --no_split */
void DirectoryModeClass::setNoSplit(bool b){
  CheckBoxNoSplit->setChecked( b );
}
