/***************************************************************************
                          directorymodeclass.h  -  description
                             -------------------
    begin                : Don Aug 28 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIRECTORYMODECLASS_H
#define DIRECTORYMODECLASS_H

#include <qwidget.h>
#include <directorymodedlg.h>

/**Dialog, where you can enter the directory mode for transcode
 *@author Cornelius Klbel
 */

class DirectoryModeClass : public DirectoryModeDlg  {
  Q_OBJECT
    public: 
  DirectoryModeClass(QWidget *parent=0, const char *name=0);
  ~DirectoryModeClass();
  /** returns the basename of the files. */
  QString getBasename();
  /** returns true, if the directorymode is activated */
  bool getDirMode();
  /** sets wether the directory mode is active or not */
  void setDirMode(bool d);
  /** Sets the filename, that was chosen. */
  void setFilename(QString f);
  /** sets the basename for the directory mode */
  void setBasename(QString b);
  /** Gets the Dirmode Type: Either OPTION or IMPORT */
  int getDirModeType();
  /** Returns wether the option --no_split is set or not */
  bool getNoSplit();
  /** Sets the checkbox --no_split */
  void setNoSplit(bool b);
  /** sets the type wether: IMPORT or OPTION */
  void setDirModeType(int t);
  enum dirModeType { OPTION, IMPORT };
  private slots: // Private slots
    /** When the checkbox is checked. */
    void slotCheckDirMode();
  /** Radiobutton import / option */
  void slotRadio();
};

#endif
