/***************************************************************************
                          execscriptclass.h  -  description
                             -------------------
    begin                : Die Aug 6 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EXECSCRIPTCLASS_H
#define EXECSCRIPTCLASS_H

#include <klocale.h>
#include <qwidget.h>
#include "ScriptDlg.h"
#include <qprocess.h>
#include <stdlib.h>

/**Dialog, der die Ausgabe der Ausfhrung des Scriptes aufnimmt.
   Doofe Sache, diese Klasse knnte auch ProcScriptClass heissen.
   Sie macht hnliches wie die ProcBaseClass.
   *@author Cornelius Klbel
   */

class ExecScriptClass : public ScriptDlg  {
  Q_OBJECT
    public: 
  ExecScriptClass(QWidget *parent=0, const char *name=0);
  ~ExecScriptClass();
  /** Setzt die fr Mplex-Progress notwendigen Daten */
  void setMplexData(QString v, QString a1, QString a2);
  /** Setzt die Daten, die notwendig sind, um den Fortschritt von
      VCDimager festzustellen. */
  void setVCDData(bool cds, QString pref);
 private: // Private attributes
  /** Nimmt den Prozess auf */
  QProcess* myProc;
  /** Nimmt das Kommando auf. Das ist eigentlich nur der Name des Shellscripts... */
  QString myKommando;
  /** Fehlermeldung */
  QString myErrorString;
  /** Dateiname des temporren Scripts */
  QString myTempScript;
  /** Fpr Mplex-Progress notwendig */
  QString myVideo;
  /** Fr Mplex-Progress notwendig */
  QString myAudio1;
  /** Timer fr den Mplex-Prozess */
  QTimer* myTimer;
  /** Fr Mplex-Progess notwendig */
  QString myAudio2;
  /** Sollen CDs gebrannt werden? */
  bool myCDsBrennen;
  /** Wie ist der Namensprefix der CDimages, wenn keine CDs gebrannt werden */
  QString myPrefix;
  /** Kennzeichnet, an welcher Stelle des Fortschrittes das Script gerade ist */
  enum typeZustand { mplex, vcd, cdr, idle };
  typeZustand myZustand;
  /** Pfad, in dem gemplext wird und vcdimger luft.
      Das ist der Pfad der Videodatei. */
  QString myPath;
  public slots: // Public slots
    /** Setzt das Kommando aus dem aufrufenden Dialog (ScriptEdit) */
    void setKommando(QString sKommando);
  /** Reagiert auf den Cancel Button */
  void slotCancel();
  /** Startet den Process, das Script. */
  void slotStart();
  /** Zeigt den OK-Button, versteckt den Cancel Button */
  void slotShowOK();
  /** Anhalten des Timers fr Mplex, VCD und CDR */
  void slotTimerStop();
  /** Der Timer fr Mplex, VCD und CDR. */
  void slotTimer();
  protected slots: // Protected slots
    /** Liest die Ausgabe des Porzesses und stellt sie grafisch dar. */
    virtual void slotReadFromStdout();
 private: // Private methods
  /** Prft wie gro?die Dateien vom vcdimager sind, um dann dementsprechend
      den Progressbar zu fllen. */
  void checkenVCD();
 private: // Private methods
  /** Prft, wie gro?die Dateien vom mplexing sind,
      um dann den ProgressBar entsprechend zu fllen. */
  void checkenMplex();
};

#endif
