/***************************************************************************
                          generatescriptclass.cpp  -  description
                             -------------------
    begin                : Son Jul 28 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "generatescriptclass.h"
#include "scripteditclass.h"

#include <qfile.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qregexp.h>

GenerateScriptClass::GenerateScriptClass(QWidget * parent, const char * name): QObject( parent, name ) {
  myParent = parent;
  myScriptTemplate = QString("/usr/bin/kavi2svcd-script");
}
GenerateScriptClass::~GenerateScriptClass(){
}
/** Setzt die Membervariable Audio1 */
void GenerateScriptClass::setAudio1(QString a1){
  myAudio1=a1;
}
/** Setzt die Membervariable myAudio2 */
void GenerateScriptClass::setAudio2(QString a2){
  myAudio2=a2;
}
/** Soll auch das CDBrennen in das Skript aufgenommen werden? */
void GenerateScriptClass::setCDsBrennen(bool cdb){
  myCDsBrennen=cdb;
}
/** Setzt die Membervariable mySpeed */
void GenerateScriptClass::setSpeed(int sp){
  mySpeed=sp;
}
/** Setzt die Membervariable device */
void GenerateScriptClass::setDevice(QString dev){
  myDevice=dev;
}
/** Setzt die Membervariable prefix */
void GenerateScriptClass::setPrefix(QString prefix){
  myPrefix=prefix;
}
/** Setzt die Membervariable mySize */
void GenerateScriptClass::setSize(QString size){
  mySize=size;
}
/** Setzt die Membervariable mySize */
void GenerateScriptClass::setType(int type){
  myType=type;
}
/** Setzt die Membervariable myVideo */
void GenerateScriptClass::setVideo(QString vid){
  myVideo=vid;
}
/** Generiert das Script ansich und speichert es in myScript.
    Zuvor sollten alle set***** aufgerufen worden sein. */
// last edited 18.08.2002
void GenerateScriptClass::generateScript(){

  QString sScript = QString(myScriptTemplate);
  QFile f(sScript);
  if (	f.open(IO_ReadOnly) ) {
    QTextStream ts( &f );
    QString test = ts.read();
    f.close();
    // hier muss ausgewertet werden.
    if ( myCDsBrennen ) { // Das Prefix setzen wird selber, weil es dem User egal sein kann.
      myPrefix="KAVI-vcdim-out";
    }
    // Regulren Ausdrcke, die gesucht werden.

    QRegExp rx1("\\$1");
    QRegExp rx2("\\$2");
    QRegExp rx3("\\$3");
    QRegExp rx4("\\$4");
    QRegExp rx5("\\$5");
    QRegExp rx6("\\$6");
    QRegExp rx7("\\$7");
    QRegExp rx8("\\$8");
    QRegExp rx9("AUDIO1\\=\\$9");
    QRegExp rx10("AUDIO2\\=\\$9");
    QRegExp rx11("SYNC\\=\\$9");
    QRegExp rx12("-z \\$9");

    QString workDir = myVideo.left( myVideo.findRev("/") );
    test.replace( rx1, '"'+workDir+'"');
    // int
    QString sType = QString("%1").arg( myType );
    test.replace( rx2, '"'+sType+'"' );
    test.replace( rx3, '"'+mySize+'"' );
    // bool
    QString sBrennen;
    if ( myCDsBrennen ) { sBrennen = "1"; } else { sBrennen="0"; }
    test.replace( rx4, '"'+sBrennen+'"' );
    // int
    QString sSpeed = QString("%1").arg( mySpeed );
    test.replace( rx5, '"'+sSpeed+'"' );
    test.replace( rx6, '"'+myDevice+'"' );
    test.replace( rx7, '"'+myPrefix+'"' );
    test.replace( rx8, '"'+myVideo+'"' );
    test.replace( rx9, "AUDIO1=\""+myAudio1+'"' );      		
    test.replace( rx10, "AUDIO2=\""+myAudio2+'"' );
    test.replace( rx11, "SYNC=\""+mySync+'"');
    test.replace( rx12, "-z \"fake\"");  		

    myScript.clear();
    myScript.append( test );
    // Nach dem generieren wird das Script nochmal angezeigt, damit es editiert werden kann.
    viewScript();
  } else {
    QMessageBox* error = new QMessageBox();
    QString errorStr=i18n("\nError reading file\n");
    errorStr.append( sScript );
    error->setText( errorStr );
    error->exec();
    delete error;
  }
}
/** Ldt das Script aus einer Datei in die Variable myScript */
bool GenerateScriptClass::loadScript(QString datei){
  QString fileName;
  QFileDialog *myFile = new QFileDialog(datei);
  myFile->setMode(QFileDialog::ExistingFile);
  myFile->setFilter( "*" );
  myFile->setCaption(i18n("Loading saved shell script..."));
  if ( myFile->exec() == QDialog::Accepted )
    {
      fileName = myFile->selectedFile();
    } // Ende vom myFile
  delete myFile;

  bool bReturn;
  QFile f(fileName);
  if (	f.open(IO_ReadOnly) ) {
    myScript.clear();
    QTextStream ts( &f );
    while ( !ts.eof() ) {
      QString zeile=ts.readLine();
      myScript.append( zeile );
    }
    f.close();
    // hier muss ausgewertet werden.
    // added 19.08.2002
    // Die Felder in mplex sollen vorbesetzt werden.
    // Die Checkboxen gefllt usw.
    QString type  = myScript.grep(QRegExp("^TYPE=")).join(" ");
    type = type.mid(6, type.length()-7);
    QString size  = myScript.grep(QRegExp("^SIZE=")).join(" ");
    size = size.mid(6, size.length()-7);
    QString cdsbrennen  = myScript.grep(QRegExp("^CDSBRENNEN=")).join(" ");
    cdsbrennen = cdsbrennen.mid(12, cdsbrennen.length()-13);
    QString speed = myScript.grep(QRegExp("^SPEED=")).join(" ");
    speed = speed.mid(7, speed.length()-8);
    QString device = myScript.grep(QRegExp("^DEVICE=")).join(" ");
    device = device.mid(8, device.length()-9);
    QString prefix = myScript.grep(QRegExp("^PREFIX=")).join(" ");
    prefix = prefix.mid(8, prefix.length()-9);
    QString video = myScript.grep(QRegExp("^VIDEO=")).join(" ");
    video = video.mid(7, video.length()-8);
    QString audio1 = myScript.grep(QRegExp("^AUDIO1=")).join(" ");
    audio1 = audio1.mid(8, audio1.length()-9);
    QString audio2 = myScript.grep(QRegExp("^AUDIO2=")).join(" ");
    audio2 = audio2.mid(8, audio2.length()-9);
    QString sync = myScript.grep(QRegExp("^SYNC=")).join(" ");
    sync = sync.mid(6, sync.length()-7);
    // Werfe das Signal
    emit scriptLoaded( type, size, cdsbrennen, speed, device,
		       prefix, video, audio1, audio2, sync );
    // Nach dem laden wird das Script nochmal angezeigt, damit es editiert werden kann.
    viewScript();
    bReturn=true;
  } else {
    QMessageBox* error = new QMessageBox();
    QString errorStr=i18n("\nError reading file\n");
    errorStr.append( fileName );
    error->setText( errorStr );
    error->exec();
    delete error;
    bReturn=false;
  }
  return bReturn;
}
/** Speichert das Script myScript in der Datei "fileName" */
bool GenerateScriptClass::saveScript(QString datei){
  QString fileName;
  QFileDialog *myFile = new QFileDialog(datei);
  myFile->setMode(QFileDialog::AnyFile);
  myFile->setFilter( "*" );
  myFile->setCaption(i18n("Saving generated shell script..."));
  if ( myFile->exec() == QDialog::Accepted )
    {
      fileName = myFile->selectedFile();
    } // Ende vom myFile
  delete myFile;

  return saving(fileName);
}
/** Liefert das generierte Script zuck */
QStringList GenerateScriptClass::getScript(){
  return myScript;
}
/** Zeigt das Script zum editieren an. */
void GenerateScriptClass::viewScript(){
  ScriptEditClass* editScript = new ScriptEditClass( this );
  editScript->setTextList( myScript );
  editScript->setVerzeichnis( "." );
  editScript->slotTextFix();
  editScript->exec();
  delete editScript;
  // TODO hiernach muss das Script bernommen werden.
}
/** Setzt das Script myScript */
void GenerateScriptClass::setScript(QStringList script){
  myScript=script;
}
/** Erledigt das eigentlich speichern, ohne Benutzerinteraktion */
bool GenerateScriptClass::saving(QString fileName){
  bool bReturn;
  QFile f(fileName);
  if (	f.open(IO_WriteOnly) ) {
    QTextStream ts( &f );
    for ( QStringList::Iterator it = myScript.begin(); it != myScript.end(); ++it ) {
      ts << *it << "\n" ;
    }
    f.close();
    bReturn=true;
  } else {
    QMessageBox* error = new QMessageBox();
    QString errorStr=i18n("\nError writing file\n");
    errorStr.append( fileName );
    error->setText( errorStr );
    error->exec();
    delete error;
    bReturn=false;
  }
  return bReturn;
}
/** Liefert myAudio1 zurck */
QString GenerateScriptClass::getAudio1(){
  return myAudio1;
}
/** Liefert myAudio2 zurck */
QString GenerateScriptClass::getAudio2(){
  return myAudio2;
}
/** Lieffert myVideo zurck */
QString GenerateScriptClass::getVideo(){
  return myVideo;
}
/** Liefert die Membervariable cdsBrennen zurck */
bool GenerateScriptClass::getCDsBrennen(){
  return myCDsBrennen;
}
/** Liefert myPrefix zurck */
QString GenerateScriptClass::getPrefix(){
  return myPrefix;
}
/** Setzt die QString-Variable fr A/V Sync */
void GenerateScriptClass::setSync(QString sync){
  mySync = sync;
}
/** Ein Workaround fr QString::replace ( QRegExp),
    das irgendwann einen Crash verursacht. */
QString GenerateScriptClass::replace(QString string, QString sString, QString rString){
  int pos = string.find(sString);
  QString neu = string.remove(pos, sString.length() );
  neu = neu.insert(pos, rString);
  return neu;
}
