/***************************************************************************
                          generatescriptclass.h  -  description
                             -------------------
    begin                : Son Jul 28 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GENERATESCRIPTCLASS_H
#define GENERATESCRIPTCLASS_H

#include <klocale.h>
#include <qobject.h>
#include <qstringlist.h>

/**Das ist die Klasse, in der die Skripte erstellt werden.
 *@author Cornelius Klbel
 */

class GenerateScriptClass : public QObject {
  Q_OBJECT
    public:
  GenerateScriptClass(QWidget * parent = 0, const char * name = 0);
  ~GenerateScriptClass();
  /** Setzt die Membervariable myAudio2 */
  void setAudio2(QString a2);
  /** Setzt die Membervariable Audio1 */
  void setAudio1(QString a1);
  /** Setzt die Membervariable mySize */
  void setSize(QString size);
  /** Setzt die Membervariable prefix */
  void setPrefix(QString prefix);
  /** Setzt die Membervariable device */
  void setDevice(QString dev);
  /** Setzt die Membervariable mySpeed */
  void setSpeed(int sp);
  /** Soll auch das CDBrennen in das Skript aufgenommen werden? */
  void setCDsBrennen(bool cdb);
  /** Setzt die Membervariable myVideo */
  void setVideo(QString vid);
  /** Setzt die Membervariable mySize */
  void setType(int type);
  /** Speichert das Script myScript in der Datei "datei" */
  bool saveScript(QString datei);
  /** Ldt das Script aus einer Datei in die Variable myScript */
  bool loadScript(QString datei);
  /** Generiert das Script ansich und speichert es in myScript.
      Zuvor sollten alle set***** aufgerufen worden sein. */
  void generateScript();
  /** Liefert das generierte Script zuck */
  QStringList getScript();
  /** Setzt das Script myScript */
  void setScript(QStringList script);
  /** Erledigt das eigentlich speichern, ohne Benutzerinteraktion */
  bool saving(QString fileName);
  /** Lieffert myVideo zurck */
  QString getVideo();
  /** Liefert myAudio2 zurck */
  QString getAudio2();
  /** Liefert myAudio1 zurck */
  QString getAudio1();
  /** Liefert myPrefix zurck */
  QString getPrefix();
  /** Liefert die Membervariable cdsBrennen zurck */
  bool getCDsBrennen();
  /** Setzt die QString-Variable fr A/V Sync */
  void setSync(QString sync);
 private: // Private attributes
  /** Typ: 1: VCD, 4: SVCD */
  int myType;
  /** Gre der Datei 680 oder 700 oder anders */
  QString mySize;
  /** Prefix fr die vcdimages */
  QString myPrefix;
  /** Zeigt an, ob CDs gebrannt werden sollen,
      also ob cdrdao im Anschluss aufgerufen wird */
  bool myCDsBrennen;
  /** Brenngeschwindigkeit */
  int mySpeed;
  /** SCSI-Device auf dem gebrannt werden soll */
  QString myDevice;
  /** Videoinput fr mplex *.m1v *.m2v */
  QString myVideo;
  /** Audiofile input fr mplex mpa */
  QString myAudio1;
  /** Audiofile input fr mplex mpa */
  QString myAudio2;
  /** Das Script wird in einer QStringList gespeichert.
      Mit grep kann ber die QStringList gesucht werden.
      Mit join kann ein einziger String erzeugt werden.
      Mit einem interator kann die Liste abgeabeitet werden. */
  QStringList myScript;
  /** Vaterdialog. Diese Klasse wird wohl immer von einem Dialog aufgreufen. */
  QWidget* myParent;
  /** Ort, wo kavi2svcd-script liegt, das template fe alle Scripts */
  QString myScriptTemplate;
  /** Die A/V Syncronisation. */
  QString mySync;


 private: // Private methods
  /** Zeigt das Script zum editieren an. */
  void viewScript();
  /** Ein Workaround fr QString::replace ( QRegExp),
      das irgendwann einen Crash verursacht. */
  QString replace(QString string, QString sString, QString rString);
 signals: // Signals
  /** Wird geworfen, wenn ein vorher gespeichertes
      Script geladen wurde. Dieses Signal gibt die
      Werte an den Mplex Tab zurck. */
  void scriptLoaded( QString, QString, QString, QString, QString,
		     QString, QString, QString, QString, QString );
};

#endif
