/***************************************************************************
                          getinfoclass.h  -  description
                             -------------------
    begin                : Mit Sep 10 2003
    copyright            : (C) 2003 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GETINFOCLASS_H
#define GETINFOCLASS_H

#include <qobject.h>
#include <qprocess.h>
#include <qstring.h>
#include <klocale.h>

/**This class is used to get information about the file.
   Frames, Resolution, File type.
   *@author Cornelius K�bel
   */

class GetInfoClass : public QObject  {
  Q_OBJECT
    public: 
  GetInfoClass();
  ~GetInfoClass();
 private:
  // These are the possible functions, to get the information
  enum typeGetInfo { AVIFIX, TRANSCODE, TCPROBE };
  public slots: // Public slots
    /** Gets the INformation of file */
    void slotGetInfo(QString file);
 private: // Private attributes
  /** The Process for get info */
  QProcess* myGetInfoProc;
  /** QString that holds the output */
  QString myGetInfoAusgabe;
  /** Error output */
  QString myGetInfoErr;
  /**  */
  typeGetInfo myGetInfo;
  /** stores the filename */
  QString myFile;
  private slots: // Private slots
    /** Collect ourput */
    void slotGetInfoReadFromStdOut();
  private slots: // Private slots
    /** Collect output */
    void slotGetInfoReadFromStdErr();
  /** Is called, when the process is ready */
  void slotGetInfoExited();
 signals: // Signals
  /** Emits the frames per second */
  void sendFPS( QString );
  /** Emits the number of Frames */
  void sendFrames( QString );
  /** Emits the Codec */
  void sendCodec( QString );
  /** Emits the Height */
  void sendHeight( QString );
  /** Emits the Width */
  void sendWidth( QString );
  void sendDuration( QString );
 signals: // Signals
  /** Emits the calculated border */
  void sendBorder(QString);
 signals: // Signals
  /** Sends the whole output of the fileinfo */
  void sendFileInfo( QString );
};

#endif
