/***************************************************************************
                          initclass.cpp  -  description
                             -------------------
    begin                : Mon Sep 23 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "initclass.h"
#include "bummerclass.h"
#include <qmessagebox.h>

InitClass::InitClass(){
  myProc = new QProcess ( this );

  connect ( myProc, SIGNAL(readyReadStdout()),
	    this, SLOT(slotReadFromStdout()) );
}
InitClass::~InitClass(){
  delete myProc;
}
/** Wird bei der Ausgabe aufgerufen */
void InitClass::slotReadFromStdout(){
  QString sAusgabe = QString(myProc->readStdout());
  myAusgabe.append( sAusgabe );
}
/** berprft, ob das Executable vorhanden ist. */
bool InitClass::checkExec(QString sExec){
  bool checkNextTime;
  // Always check next time
  checkNextTime=true;
  myAusgabe = QString("");
  myProc->clearArguments();
  myProc->addArgument("whereis");
  myProc->addArgument(sExec);
  if ( myProc->start() ) {
    // Warten, so lange whereis luft.
    while (myProc->isRunning()) { };
    // Diesen Dreher muss ich machen, weil die Ausgabe erst gelesen wird,
    // nachdem der Prozess beendet ist.
    if ( myAusgabe.isEmpty() ) {
      slotReadFromStdout();
    }
    if ( myAusgabe.find("/")<0 ) { // Kein Pfad vorhanden
      BummerClass* error = new BummerClass();
      error->setText(i18n(" Can not find the program: %1").arg(sExec));
      error->exec();
      // Check if the ckeckbox was checked
      // If so, we return the command
      checkNextTime=!error->getChecked();
      delete error;
    } 
  }
  return checkNextTime;
}
/** LIefert die Ausgabe des whereis-Befehls zurck. */
QString InitClass::getAusgabe(){
  return myAusgabe;
}
/** Returns the lib path of transcode */
bool InitClass::getTranscodeLib(){
  myAusgabe = QString("");
  myProc->clearArguments();
  myProc->addArgument("tcmodinfo");
  myProc->addArgument("-p");
  if ( myProc->start() ) {
    // Warten, so lange Prozess luft.
    while (myProc->isRunning()) { };
    // Diesen Dreher muss ich machen, weil die Ausgabe erst gelesen wird,
    // nachdem der Prozess beendet ist.
    if ( myAusgabe.isEmpty() ) {
      slotReadFromStdout();
    }
    if ( myAusgabe.find("/")<0 ) { // no path found
      QMessageBox* error = new QMessageBox();
      error->setText(i18n("No output of tcmodinfo -p"));
      error->exec();
      delete error;
      return false;
    } else {
      return true;
    }
  }
  return false;
}
