/***************************************************************************
                          logclass.h  -  description
                             -------------------
    begin                : Don Aug 21 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOGCLASS_H
#define LOGCLASS_H

#include <qobject.h>
#include <qfile.h>

/**Class that provides logging funtionality
 *@author Cornelius Klbel
 */

class LogClass : public QObject  {
 public: 
  LogClass();
  ~LogClass();
  /** Returns true if the logfile exists */
  bool fileExists();
  /** Sets the filename of the log file. */
  int setFileName(QString s);
 private: // Private attributes
  /** Name of the logfile */
  QString myFileName;
  /** the logfile */
  QFile myFile;
  public slots: // Public slots
    /** write the log text */
    int slotLog(QString logtext);
};

#endif
