/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Die Jul 23 11:52:25 CEST 2002
    copyright            : (C) 2002 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include <qsplashscreen.h>
#include <qpixmap.h>

#include "kavi2svcd.h"

static const char *description =
I18N_NOOP("Kavi2svcd generates a VideoCD or a Super VideoCD from an avi-file.");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
  {
    { "d", I18N_NOOP("debug mode"), 0 },
    { 0, 0, 0 }
    // INSERT YOUR COMMANDLINE OPTIONS HERE
  };

int mainDebug;

int main(int argc, char *argv[])
{
  // init data
  KAboutData aboutData( "kavi2svcd", "KAvi2svcd",
			VERSION, description, KAboutData::License_GPL,
			I18N_NOOP("(c) 2002, 2003, 2004, 2005, Cornelius Koelbel"), 0,
			I18N_NOOP("http://www.cornelinux.de/web/linux/kavi2svcd/index-english.html"),
			"cornelius.koelbel@gmx.de");
  aboutData.addAuthor(I18N_NOOP("Cornelius Koelbel"), 0,
		      "cornelius.koelbel@gmx.de",
		      "http://www.cornelinux.de");
  aboutData.addCredit("Sojus", I18N_NOOP("Fast resizing discussion..."));
  aboutData.addCredit("Jean-Jacques Freulon", I18N_NOOP("Translation to French and some Icons."));
  aboutData.addCredit("Quique", I18N_NOOP("Translation to Spanish."));
  aboutData.addCredit("Alejandro Garcia Andrade", I18N_NOOP("Translation to Spanish."));
  aboutData.addCredit("Sven Powalla", I18N_NOOP("Designing Icons"));

  KCmdLineArgs::init( argc, argv, &aboutData );
  KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
  if ( args->isSet("d")) {
    printf("Entering debug mode...\n\n");
    mainDebug=1;
  } else {
    mainDebug=0;
  }
  
  KApplication a;	
  
  // start a splashscreen
  // QPixmap pixmap( "/data/vonFranzi/Theodor-Gesicht.png" );
  // QSplashScreen *splash = new QSplashScreen( pixmap );
  // splash->show();
  
  // kavi2svcd evtl. im Debugmodus
  Kavi2svcd *kavi2svcd = new Kavi2svcd(mainDebug);
  kavi2svcd->setAboutData(&aboutData);
	
  a.setMainWidget(kavi2svcd);
  kavi2svcd->show();

  // we end the splashscreen, when kavi is ready
  // splash->finish( kavi2svcd );
  // delete splash;
  
  return a.exec();
}
