/***************************************************************************
                          mplex.h  -  description
                             -------------------
    begin                : Don Jul 25 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MPLEX_H
#define MPLEX_H

#include <klocale.h>
#include <qwidget.h>
#include "procbaseclass.h"
#include <qprocess.h>
#include <qtimer.h>

/**Prozess, der das Mplex ausfhrt. Auch er erbt von ProcBaseClass und
   somit von dem Dialog TranscodeDlg.
   *@author Cornelius Klbel
   */

class Mplex : public ProcBaseClass  {
  Q_OBJECT
    public: 
  Mplex(QWidget *parent=0, const char *name=0);
  ~Mplex();
  /** Setzt die Ausgabedateien */
  void setOutput(QString o);
  /** Setzt die Videodatei */
  void setVideo(QString v);
  /** Setzt die Audiodateien */
  void setAudio(QString a1, QString a2);
  /** Berechnet den Fortschritt beim mplexing. */
  static int progress(QString myVideo, QString myAudio1, QString myAudio2, QString myOutput);
 private: // Private attributes
  /**  */
  QTimer* myTimer;
  /** Videodatei fr Mplexing */
  QString myVideo;
  /** Audiodatei fr Mplexing */
  QString myAudio1;
  /** Audiodatei fr Mplexing */
  QString myAudio2;
  /** Ausgabedateien */
  QString myOutput;
  private slots: // Public slots
    /** Wenn der Prozess zu Ende ist, wird der Timer angehalten. */
    void slotTimerStop();
  /** Wird nach einem bestimmten Zeitintervall aufgerufen, damit der Fortschritt geprft werden kann */
  void slotTimer();
};

#endif
