/***************************************************************************
                          prefclass.cpp  -  description
                             -------------------
    begin                : Fre Jul 26 2002
    copyright            : (C) 2002 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "prefclass.h"
#include "myqlineedit.h"

#include <qfiledialog.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qtextstream.h>
#include <qregexp.h>
#include <qradiobutton.h>
#include <qlabel.h>
#include <qurl.h>

PrefClass::PrefClass(Kavi2svcd* parent, const char *name, bool load, QString datei) : prefDlg(parent,name) {
  // load gibt an, ob die Daten zu Beginn geladen werden sollen.
  QString kdeHome=QString(getenv( "KDEHOME" ));
  if (kdeHome.isEmpty()) {
    myPfad=QDir::homeDirPath();
    myPfad.append("/.kde");
  } else {
    myPfad=kdeHome;
  }
  myPfad.append("/share/apps/kavi2svcd/");
  myDatei=datei;
  myParent = parent;
  
  fillProfileCombo(myDatei);
  
  if (load) slotLoad();  
  slotDeviceBlank();
}
PrefClass::~PrefClass(){
}
/** Hier werden die Daten gespeichert */
void PrefClass::slotSave(){
  // hier wird in das Verzeichnis die Datei geschrieben.
  QString datei=comboBoxProfile->currentText();
  QFile f(myPfad+datei+".conf");
  if (	f.open(IO_WriteOnly) ) {
    QTextStream ts( &f );
    ts << "VideoPfad:";
    ts << LineEditDir->text();
    ts << "\nStandardType:";
    ts << ComboBoxType->currentItem();
    ts << "\nStandardSize:";
    ts << LineEditSize->text();
    ts << "\nStandardSegment:";
    ts << LineEditSegment->text();
    ts << "\nScsiDevice:";
    ts << LineEditDevice->text();
    ts << "\nBurnSpeed:";
    ts << SpinBoxSpeed->value();
    ts << "\nEject:";
    ts << CheckBoxEject->isChecked();
    ts << "\nOverburn:";
    ts << checkBoxOverburn->isChecked();
    ts << "\nK-Option:";
    ts << CheckBoxK->isChecked();
    ts << "\nV-Option:";
    ts << CheckBoxV->isChecked();
    ts << "\nZ-Option:";
    ts << checkBoxZ->isChecked();
    ts << "\nFastZ-Option:";
    ts << checkBoxFastZ->isChecked();
    ts << "\nPreview-Kommando:";
    ts << LineEditPreview->text();
    ts << "\nOption_Transcode:";
    ts << LineEditTranscodeOption->text();
    ts << "\nOption_Mplex:";
    ts << LineEditMplexOption->text();
    ts << "\nOption_VCD:";
    ts << LineEditVCDOption->text();
    ts << "\nOption_CDR:";
    ts << LineEditCDROption->text();
    ts << "\nCDR_Driver:";
    ts << LineEditDrivers->text();
    ts << "\nCDR_Driver_standard:";
    ts << ComboBoxDriver->currentItem();
    ts << "\nBlankCDRW:";
    ts << CheckBoxBlankCDRW->isChecked();
    ts << "\nBlankCDRWCmd:";
    ts << ComboBoxBlankCDRW->currentText();
    // The nice levels
    ts << "\nnice-transcode:";
    ts << checkBoxTranscode->isChecked();
    ts << "\nnlevel-transcode:";
    ts << spinBoxTranscode->value();
    ts << "\nnice-mplex:";
    ts << checkBoxMplex->isChecked();
    ts << "\nnlevel-mplex:";
    ts << spinBoxMplex->value();
    ts << "\nnice-vcdimager:";
    ts << checkBoxVCDImager->isChecked();
    ts << "\nnlevel-vcdimager:";
    ts << spinBoxVCDImager->value();
    ts << "\nnice-cdrdao:";
    ts << checkBoxCdrdao->isChecked();
    ts << "\nnlevel-cdrdao:";
    ts << spinBoxCdrdao->value();
    ts << "\ncdRecordType:";
    ts << radioButtonCDRdao->isChecked();
    ts << "\nLogFile:";
    ts << lineEditLogFile->text();
    ts << "\nvideoFormat:";
    ts << radioButtonPAL->isChecked();
    ts << "\nNoCheckPrograms:";
    ts << myCheckPrograms;
    ts << "\nSubTitleEditor:";
    ts << LineEditSubEdit->text();
    ts << "\nSubTitleViewer:";
    ts << LineEditSubView->text();
    ts << "\nPreviewCUE:";
    ts << LineEditPreviewCUE->text();
    ts << "\nOutputTranscode:";
    ts << lineEditOutputTranscode->text();
    ts << "\nOutputMplex:";
    ts << lineEditOutputMplex->text();
    ts << "\nOutputVCD:";
    ts << lineEditOutputVCD->text();
    ts << "\nStartupBehaviour:";
    ts << comboBoxStartup->currentItem();
    ts << "\nEncoding:";
    ts << comboBoxEncoding->currentItem();
    ts << "\nTranscodeTool:";
    ts << comboBoxTranscodeTool->currentText();
    // added on 27.12.2004
    ts << "\nImportModule:";
    ts << comboBoxImportModule->currentText();
    ts << "\nExportFPS:";
    ts << comboBoxFPS->currentText();
    ts << "\nKeepASR:";
    ts << checkBoxKeepASR->isChecked();
    ts << "\nImportASR:";
    ts << comboBoxImportASR->currentItem();
    ts << "\nExportASR:";
    ts << comboBoxExportASR->currentItem();
    ts << "\nDVDBitrate:";
    ts << lineEditDVDBitrate->text();
    f.close();
  } else {
    QMessageBox* error = new QMessageBox();
    QString errorStr=i18n("\nError writing file\n");
    errorStr.append( myPfad );
    errorStr.append( comboBoxProfile->currentText() );
    errorStr.append( ".conf" );
    error->setText( errorStr );
    error->exec();
    delete error;
  }

  // Au�rdem mssen noch die Werte in kavi2svcd gesetzt werden!
  setPrefs();
  // Danach den savebutton ausblenden und erst wieder einblenden, wenn
  // ein Datum ver�dert wurde.
  PushButtonSave->hide();
  
  fillProfileCombo(datei);
}

/** L�t die Daten aus der Datei und
    zeigt sie in den Felder an. */
void PrefClass::slotLoad(){
  QString muell, pfad, device, size, preview, optTranscode, optMplex, optVCD, optCDR,
    cdrDriver, segment, blankCmd, logFile, sSubView, sSubEdit, previewCUE;
  int iType=0, iSpeed=0, iEject=0, iOverburn=0, iK=0, iV=0, iB=0, iZ=0, iFastZ=0, iVideoFormat=0, iStartup=0;
  int optCTranscode=0, optCMplex=0, optCVCDImager=0, optCCdrdao=0,
    optITranscode=0, optIMplex=0, optIVCDImager=0, optICdrdao=0, iCDRType=0;
  int iEncoding=0;
  QString sTool;
  bool bTranscode=false;
  bool bMplex=false;
  bool bVCDImager=false;
  bool bCdrdao=false;
  bool bEject=false;
  bool bOverburn=false;
  bool bK=false;
  bool bV=false;
  bool bB=false;
  bool bZ=false;
  bool bfZ=false;
  bool bCDRType=false; 
  int  iKeep;
  int iBitrate=6000;
  
  // set startup, if it is not set
  // Start with ASK
  iStartup=0;
    
  QString currentFile=comboBoxProfile->currentText();
  QFile f(myPfad+currentFile+".conf");
  myDriverList.clear();
  myDriverList.append(i18n("--none--"));
  if (	f.open(IO_ReadOnly) ) {
    QTextStream ts( &f );
    QString test = ts.readLine();
    while ( test != NULL ) {
      int pos = test.find(":");
      QString option = test.left(pos);
      QString value = test.right( test.length()-pos-1);
      if ( option == "VideoPfad"){ pfad = value; }
      else if ( option == "StandardType"){ iType = value.toInt();}
      else if ( option == "StandardSize"){ size = value;}
      else if ( option == "StandardSegment"){ segment = value;}
      else if ( option == "ScsiDevice"){ device= value;}
      else if ( option == "BurnSpeed"){ iSpeed = value.toInt();}
      else if ( option == "Eject"){ iEject = value.toInt();}
      else if ( option == "Overburn") { iOverburn = value.toInt();}
      else if ( option == "K-Option"){ iK = value.toInt();}
      else if ( option == "V-Option"){ iV = value.toInt();}
      else if ( option == "Z-Option"){ iZ = value.toInt();}
      else if ( option == "FastZ-Option" ) { iFastZ = value.toInt(); }
      else if ( option == "BlankCDRW") { iB = value.toInt();}
      else if ( option == "BlankCDRWCmd") { blankCmd = value; }
      else if ( option == "Preview-Kommando"){ preview = value;}
      else if ( option == "Option_Transcode"){ optTranscode = value;}
      else if ( option == "Option_Mplex"){ optMplex = value;}
      else if ( option == "Option_VCD"){ optVCD = value;}
      else if ( option == "Option_CDR"){ optCDR = value;}
      else if ( option == "nice-transcode"){ optCTranscode = value.toInt(); }
      else if ( option == "nice-mplex"){ optCMplex = value.toInt(); }
      else if ( option == "nice-vcdimager"){ optCVCDImager = value.toInt(); }
      else if ( option == "nice-cdrdao"){ optCCdrdao = value.toInt(); }
      else if ( option == "nlevel-transcode"){ optITranscode = value.toInt(); }
      else if ( option == "nlevel-mplex"){ optIMplex = value.toInt(); }
      else if ( option == "nlevel-vcdimgaer"){ optIVCDImager = value.toInt(); }
      else if ( option == "nlevel-cdrdao"){ optICdrdao = value.toInt(); }
      else if ( option == "cdRecordType"){ iCDRType = value.toInt(); }
      else if ( option == "LogFile"){ logFile = value; }
      else if ( option == "videoFormat") { iVideoFormat = value.toInt(); }
      else if ( option == "NoCheckPrograms") { myCheckPrograms = value; }
      else if ( option == "SubTitleEditor") { sSubEdit = value; }
      else if ( option == "SubTitleViewer") { sSubView = value; }
      else if ( option == "PreviewCUE") { previewCUE=value; }
      else if ( option == "OutputTranscode") { lineEditOutputTranscode->setText( value ); }
      else if ( option == "OutputMplex") { lineEditOutputMplex->setText( value ); }
      else if ( option == "OutputVCD") { lineEditOutputVCD->setText( value ); }
      else if ( option == "StartupBehaviour" ) { iStartup=value.toInt(); }
      else if ( option == "Encoding" ) { iEncoding=value.toInt(); }
      else if ( option == "DVDBitrate" ) { iBitrate=value.toInt(); }
      else if ( option == "TranscodeTool" ) { sTool=value; }
      else if ( option == "CDR_Driver"){
	if (value.isEmpty()) {
	  value=STANDARD_DRIVER;
	}
	cdrDriver=value;
	int pos = value.find(",");
	while ( pos > -1 ) {
	  myDriverList.append( value.left( pos ) );
	  value = value.right(value.length()-pos-1);
	  pos = value.find(",");
	}
      }
      else if ( option == "CDR_Driver_standard") { myDriverStandard=value.toInt(); }
      // added 27.12.2004
      else if (option=="ImportModule") {comboBoxImportModule->setCurrentText(value);}
      else if (option=="ExportFPS") {comboBoxFPS->setCurrentText(value); }
      else if (option=="KeepASR") { iKeep=value.toInt();
      					checkBoxKeepASR->setChecked(iKeep);
					}
      else if (option=="ImportASR") {comboBoxImportASR->setCurrentItem(value.toInt());}
      else if (option=="ExportASR") {comboBoxExportASR->setCurrentItem(value.toInt());}
      test = ts.readLine();
    }
    if (iEject==1) bEject=true;
    if (iOverburn==1) bOverburn=true;
    if (iK==1) bK=true;
    if (iV==1) bV=true;
    if (iB==1) bB=true;
    if (iZ==1) bZ=true;
    if (iFastZ==1) bfZ=true;
    if (optCTranscode==1) bTranscode=true;
    if (optCMplex==1) bMplex=true;
    if (optCVCDImager==1) bVCDImager=true;
    if (optCCdrdao==1) bCdrdao=true;
    if (iCDRType==1) bCDRType=true;
      
    f.close();
    // Besetzen der Widgets
    comboBoxTranscodeTool->setCurrentText( sTool );
    comboBoxEncoding->setCurrentItem( iEncoding );
    lineEditDVDBitrate->setText( QString("%1").arg(iBitrate));
    comboBoxStartup->setCurrentItem( iStartup ); 
    radioButtonPAL->setChecked( iVideoFormat );
    radioButtonNTSC->setChecked( !iVideoFormat );
    LineEditDir->setText( pfad );
    ComboBoxType->setCurrentItem( iType );
    LineEditSize->setText( size );
    LineEditSegment->setText( segment );
    LineEditDevice->setText( device);
    SpinBoxSpeed->setValue( iSpeed );
    CheckBoxEject->setChecked( bEject );
    checkBoxOverburn->setChecked( bOverburn );
    CheckBoxK->setChecked( bK );
    CheckBoxV->setChecked( bV );
    checkBoxZ->setChecked( bZ );
    checkBoxFastZ->setChecked( bfZ );
    CheckBoxBlankCDRW->setChecked( bB );
    LineEditPreview->setText( preview );
    LineEditPreviewCUE->setText( previewCUE );
    LineEditTranscodeOption->setText( optTranscode );
    LineEditMplexOption->setText( optMplex );
    LineEditVCDOption->setText( optVCD );
    LineEditCDROption->setText( optCDR );
    LineEditDrivers->setText( cdrDriver );
    ComboBoxDriver->clear();
    ComboBoxDriver->insertStringList( myDriverList );
    ComboBoxDriver->setCurrentItem( myDriverStandard );
    ComboBoxBlankCDRW->insertItem( blankCmd, 0 );
    lineEditLogFile->setText( logFile );
    LineEditSubView->setText( sSubView );
    LineEditSubEdit->setText( sSubEdit );
    // set nice-levels
    checkBoxTranscode->setChecked( bTranscode );
    checkBoxMplex->setChecked( bMplex );
    checkBoxVCDImager->setChecked( bVCDImager );
    checkBoxCdrdao->setChecked( bCdrdao );
    spinBoxTranscode->setValue( optITranscode );
    spinBoxMplex->setValue( optIMplex );
    spinBoxVCDImager->setValue( optIVCDImager );
    spinBoxCdrdao->setValue( optICdrdao );
    // grey the spinBoxes, that are not checked
    slotChecked();
    // CDR Type
    radioButtonCDRdao->setChecked( bCDRType );
    radioButtonCDRecord->setChecked( !bCDRType );
		 
    setPrefs();
  } else {
    QMessageBox* error = new QMessageBox();
    QString errorStr=i18n("\nError reading file\n");
    errorStr.append( myPfad );
    errorStr.append( comboBoxProfile->currentText() );
    errorStr.append( ".conf" );
    error->setText( errorStr );
    error->exec();
    delete error;
  }
}

/** Hier wird das StandardVerzeichnis ausgesucht. */
void PrefClass::slotOpenDir(){
  QString fileName;
  QFileDialog *myOutputFile = new QFileDialog();
  myOutputFile->setMode(QFileDialog::Directory);
  myOutputFile->setFilter("*");
  if ( myOutputFile->exec() == QDialog::Accepted )
    {
      fileName = myOutputFile->selectedFile();
      LineEditDir->setText(fileName);
    } // Ende vom myInputFile
  delete myOutputFile;

}
/** Zeigt, wenn Daten ge�dert wurden, wieder den Save-Button */
void PrefClass::slotShowSave(){
  PushButtonSave->show();
}

/** Ruft die Funktion auf, die in dem Parent (kavi2svcd) wiederum
    die Preferences setzt.
    Diese Funktion wird auch von au�rhalb aufgreunfen.
    kavi2svcd ruft sie auf, wenn es seine Werte haben will.*/
void PrefClass::setPrefs(){
  Kavi2svcd::prefData data;
  if (radioButtonPAL->isChecked()) { data.videoFormat=1;}else{data.videoFormat=0;}
  data.DVDBitrate=lineEditDVDBitrate->text().toInt();
  data.editDir=LineEditDir->text();
  data.standardVcdType=ComboBoxType->currentItem();
  data.size=LineEditSize->text();
  data.device=LineEditDevice->text();
  data.speed=SpinBoxSpeed->value();
  data.eject=CheckBoxEject->isChecked();
  data.overburn=checkBoxOverburn->isChecked();
  data.K=CheckBoxK->isChecked();
  data.V=CheckBoxV->isChecked();
  data.Z=checkBoxZ->isChecked();
  data.fastZ=checkBoxFastZ->isChecked();
  data.previewCommand=LineEditPreview->text();
  data.transcodeOption=LineEditTranscodeOption->text();
  data.mplexOption=LineEditMplexOption->text();
  data.vcdOption=LineEditVCDOption->text();
  data.cdrOption=LineEditCDROption->text();
  data.driverList=myDriverList;
  data.driver=ComboBoxDriver->currentItem();
  data.segment=LineEditSegment->text();
  data.bBlankCDRW=CheckBoxBlankCDRW->isChecked();
  data.sBlankCDRW=ComboBoxBlankCDRW->currentText();
  data.niceTranscode=checkBoxTranscode->isChecked();
  data.niceValueTranscode=spinBoxTranscode->value();
  data.niceMplex=checkBoxMplex->isChecked();
  data.niceValueMplex=spinBoxMplex->value();
  data.niceVcd=checkBoxVCDImager->isChecked();
  data.niceValueVcd=spinBoxVCDImager->value();
  data.niceCdr=checkBoxCdrdao->isChecked();
  data.niceValueCdr=spinBoxCdrdao->value();
  data.useCDRDAOnotCDRECORD=radioButtonCDRdao->isChecked();
  data.logFile=lineEditLogFile->text();
  data.programsNotCheck=myCheckPrograms;
  data.subtitleViewProgram=LineEditSubView->text();
  data.subtitleEditProgram=LineEditSubEdit->text();
  data.previewCUE=LineEditPreviewCUE->text();
  data.outputTranscode=lineEditOutputTranscode->text();
  data.outputMplex=lineEditOutputMplex->text();
  data.outputVCD=lineEditOutputVCD->text();
  data.startup=comboBoxStartup->currentItem();
  data.encoding=comboBoxEncoding->currentItem();
  data.profile=comboBoxProfile->currentText();
  data.TranscodeTool=comboBoxTranscodeTool->currentText();
  data.ImportModule=comboBoxImportModule->currentText();
  data.ExportFPS=comboBoxFPS->currentText();
  data.KeepASR=checkBoxKeepASR->isChecked();
  data.ImportASR=comboBoxImportASR->currentItem();
  data.ExportASR=comboBoxExportASR->currentItem();
  // pass the data to the parent
  myParent->setPreferences(data);
}

//
/** Inserts the command into the combobox if the device was changed */
void PrefClass::slotDeviceBlank(){
  ComboBoxBlankCDRW->insertItem("cdrecord blank=fast dev="+LineEditDevice->text(),0);
}
/** ckecks which checkbox on the nice-tab is checked. */
void PrefClass::slotChecked(){
  spinBoxTranscode->setEnabled(checkBoxTranscode->isChecked());
  spinBoxMplex->setEnabled(checkBoxMplex->isChecked());
  spinBoxVCDImager->setEnabled(checkBoxVCDImager->isChecked());
  spinBoxCdrdao->setEnabled(checkBoxCdrdao->isChecked());
}
/** wether cdrdao or cdrecord will be used. */
void PrefClass::slotCdrecord(){
  bool bType=radioButtonCDRdao->isChecked();
  TextLabelPossibleDriver->setEnabled(bType);
  TextLabelStandardDriver->setEnabled(bType);
  LineEditDrivers->setEnabled(bType);
  ComboBoxDriver->setEnabled(bType);
}

/** �fnet ein Dateiladefenster zur Auswahl des Previewers */
void PrefClass::slotOpenPreview(){
  QString fileName;
  QFileDialog *myFile = new QFileDialog();
  myFile->setMode(QFileDialog::ExistingFile);
  myFile->setFilter("*");
  if ( myFile->exec() == QDialog::Accepted )
    {
      fileName = myFile->selectedFile();
      LineEditPreview->setText(fileName);
    } // Ende vom myInputFile
  delete myFile;
}

/** Here you can choos a logfile, where all output of the processes will be logged to. */
void PrefClass::slotOpenLogFile(){
  QString fileName;
  QFileDialog *myFile = new QFileDialog();
  myFile->setMode(QFileDialog::AnyFile);
  myFile->setFilter("*");
  if ( myFile->exec() == QDialog::Accepted )
    {
      fileName = myFile->selectedFile();
      lineEditLogFile->setText(fileName);
    } // Ende vom myInputFile
  delete myFile;
}
/** passes the Programs that shall not be checked for saving. */
void PrefClass::slotSetCheckPrograms(QString s){
  myCheckPrograms=s;
  slotSave();
}
/** copies the outputdir from transcode to mplex and vcdimager */
void PrefClass::slotCopyOutput(){
  lineEditOutputMplex->setText( lineEditOutputTranscode->text() );
  lineEditOutputVCD->setText( lineEditOutputTranscode->text() );
}
/** opens a filedialog for the output directory of transcode */
void PrefClass::slotOutputTranscode(){
  QString dir=lineEditOutputTranscode->text();
  if ( dir.isEmpty() ) { dir=LineEditDir->text(); }
  QFileDialog* file = new QFileDialog(dir);
  file->setMode( QFileDialog::DirectoryOnly );
  if ( file->exec() ) {
    // fill lineEditOutputTranscode
    lineEditOutputTranscode->setText( file->selectedFile() );
    slotShowSave();
  }
  delete file;
}
/** opens file dialog */
void PrefClass::slotOutputMplex(){
  QString dir=lineEditOutputMplex->text();
  if ( dir.isEmpty() ) { dir=LineEditDir->text(); }
  QFileDialog* file = new QFileDialog(dir);
  file->setMode( QFileDialog::DirectoryOnly );
  if ( file->exec() ) {
    // fill lineEditOutputTranscode
    lineEditOutputMplex->setText( file->selectedFile() );
    slotShowSave();
  }
  delete file;
}
/** opens file dialog */
void PrefClass::slotOutputVCD(){
  QString dir=lineEditOutputVCD->text();
  if ( dir.isEmpty() ) { dir=LineEditDir->text(); }
  QFileDialog* file = new QFileDialog(dir);
  file->setMode( QFileDialog::DirectoryOnly );
  if ( file->exec() ) {
    // fill lineEditOutputTranscode
    lineEditOutputVCD->setText( file->selectedFile() );
    slotShowSave();
  }
  delete file;
}

/*!
    \fn PrefClass::fillPofileCombo()
 */
void PrefClass::fillProfileCombo(QString currentFile)
{
    /// Here we fill the combo box!
  // Read all *.conf files in pfad
        QDir d(myPfad);
        d.setFilter( QDir::Files | QDir::Hidden | QDir::NoSymLinks );
	d.setNameFilter( "*.conf" );
        d.setSorting( QDir::Size | QDir::Reversed );

        const QFileInfoList *list = d.entryInfoList();
        QFileInfoListIterator it( *list );
        QFileInfo *fi;  
	comboBoxProfile->clear();
        while ( (fi = it.current()) != 0 ) {
	    QString filename=fi->fileName().latin1();
	    filename=filename.left(filename.find(".conf"));
	    comboBoxProfile->insertItem(filename);
            ++it;
        }
	comboBoxProfile->setCurrentText(currentFile);
}


/*!
    \fn PrefClass::fillImportModules(QStringList l)
 */
void PrefClass::fillImportModules(QStringList l)
{
    comboBoxImportModule->clear();
    comboBoxImportModule->insertStringList(l);
}

