/***************************************************************************
                          prefclass.h  -  description
                             -------------------
    begin                : Fre Jul 26 2002
    copyright            : (C) 2002 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREFCLASS_H
#define PREFCLASS_H

#include <stdlib.h>
#include <klocale.h>
#include <qwidget.h>
#include "prefdlg.h"
#include "kavi2svcd.h"

/**Dialog mit den Preferences
 *@author Cornelius K�bel
 */

class PrefClass : public prefDlg  {
  Q_OBJECT
    public: 
  PrefClass(Kavi2svcd *parent=0, const char *name=0, bool load=true, QString datei="kavi2svcd");
  ~PrefClass();
  /** L�t die Daten aus der Datei und
      zeigt sie in den Felder an. */
  void slotLoad();
  /** Ruft die Funktion auf, die in dem Parent (kavi2svcd) wiederum
      die Preferences setzt. */
  void setPrefs();
  public slots: // Public slots
    /** Hier wird das StandardVerzeichnis ausgesucht. */
    void slotOpenDir();
  public slots: // Public slots
    /** Hier werden die Daten gespeichert */
    void slotSave();;
  /** �fnet ein DAteiladefenster zur Auswahl des Previewers */
  void slotOpenPreview();
  /** passes the Programs that shall not be checked for saving. */
  void slotSetCheckPrograms(QString s);
  void fillImportModules(QStringList l);
  private slots: // Private slots
    /** Zeigt, wenn Daten ge?dert wurden, wieder den Save-Button */
    void slotShowSave();
  /** ckecks which checkbox on the nice-tab is checked. */
  void slotChecked();
  /** wether cdrdao or cdrecord will be used. */
  void slotCdrecord();
  /** Here you can choos a logfile, where all output of the processes will be logged to. */
  void slotOpenLogFile();
  /** copies the outputdir from transcode to mplex and vcdimager */
  void slotCopyOutput();
 private: // Private attributes
  /** Das Aufrufende Objekt, in diesem Fall Kavi2svcd */
  Kavi2svcd* myParent;
  /** Conf.Datei */
  QString myDatei;
  QString myPfad;
  /** Liste der Driver fr Mplex */
  QStringList myDriverList;
  /** List of Programs, that shall NOT be checked */
  QString myCheckPrograms;
  /** Standard Driver fr cdrdao */
  int myDriverStandard;
  /** Die standardm�igen Treiber, wenn sie noch keiner editiert hat */
#define STANDARD_DRIVER "cdd2600, plextor, plextor-scan, generic-mmc, generic-mmc-raw, ricoh-mp6200, yamaha-cdr10x, teac-cdr55, sony-cdu920, sony-cdu948, taiyo-yuden, toshiba";
  protected slots: // Protected slots
    /** Inserts the command into the combobox if the device was changed */
    void slotDeviceBlank();
  /** opens a filedialog for the output directory of transcode */
  void slotOutputTranscode();
  /** opens file dialog
   */
  void slotOutputVCD();
  /** opens file dialog */
  void slotOutputMplex();

private:
    void fillProfileCombo(QString currentFile);

};

#endif
