/***************************************************************************
                          profile.h  -  description
                             -------------------
    begin                : Die Apr 8 2003
    copyright            : (C) 2003 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <klocale.h>

#ifndef PROFILE_H
#define PROFILE_H

#include <qwidget.h>
#include <profileDlg.h>
#include <qstringlist.h>
#include <kavi2svcd.h>

/**
 *@author Cornelius K�bel
 */

class Profile : public profileDlg {
  Q_OBJECT
    public:
  Profile(Kavi2svcd *parent=0, const char *name=0);
  ~Profile();
  /** sets the list for profile */
  void setList( QStringList list);
  /** Sets the Checkbox */
  void setUseProfile(bool bUse);
  /** saves the profile */
  void save();
  protected slots: // Protected slots
    /** Adds a key to the list */
    void slotAdd();
  /** deletes an entry from the profile list */
  void slotDel();
  /** shows the value of the selected item */
  void slotShowValue();
  /** The Button OK is pressed. */
  void slotOK();
  /** Resets the values to reasonable values */
  void slotReset();
 protected: // Protected methods
  /** get the value for a key. If not in list, returns "not_in_list" */
  QString getValue(QString key);
  /** exports the Listview to a Stringlist */
  void exportListView();
  /** change the value, when the key in the comboBox was changed. */
  void slotChangeValue();
  /** imports the Stringlist to the Listview */
  void importListView();
  /** List, that holds the key / values pairs */
  QStringList myStringList;
 private: // Private attributes
  /** profile file */
  QString myDatei;
  /** the parent of the dialog */
  Kavi2svcd* myParent;
 private: // Private methods
  /** loads the xsvcd.prof */
  void load();
};

#endif
