/***************************************************************************
                          rangeofframesclass.cpp  -  description
                             -------------------
    begin                : Die Jun 3 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "rangeofframesclass.h"

#include <qlineedit.h>
#include <qslider.h>
#include <qlabel.h>
#include <qcheckbox.h>

RangeOfFramesClass::RangeOfFramesClass(Kavi2svcd *parent, const char *name ) : RangeOfFramesDlg(parent,name) {
  myParent=parent;
}
RangeOfFramesClass::~RangeOfFramesClass(){
}
/** Selects all Frames */
void RangeOfFramesClass::slotAll(){
  bool bChoose = !checkBoxAll->isChecked();
  if ( checkBoxAll->isChecked() ) {
    myFirst=myMinFrame;
    myLast=myMaxFrame;
    slotShowFrames();
  }
  lineEditFirst->setEnabled(bChoose);
  lineEditLast->setEnabled(bChoose);
  sliderFirst->setEnabled(bChoose);
  sliderLast->setEnabled(bChoose);
  textLabelFirst->setEnabled(bChoose);
  textLabelLast->setEnabled(bChoose);
}
/** Sets the gui depending on the frames */
void RangeOfFramesClass::slotShowFrames(){
  sliderFirst->setValue( myFirst );
  sliderLast->setValue( myLast );
  QString hilfe2;
  hilfe2.setNum(myLast);
  lineEditLast->setText( hilfe2 );
  QString hilfe;
  hilfe.setNum(myFirst);
  lineEditFirst->setText( hilfe );
}
/** sets the maximum/minimum number of frames */
void RangeOfFramesClass::setMinMax(long min,long max){
  myMaxFrame=max;
  myMinFrame=min;
  myFirst=min;
  myLast=max;
  sliderFirst->setMinValue( min );
  sliderFirst->setMaxValue( max );
  sliderLast->setMinValue( min );
  sliderLast->setMaxValue( max );
}
/** Is called, when the slieder ist moved */
void RangeOfFramesClass::slotSliderLastChanged(int value){
  myLast=value;
  if (myLast<=myFirst && myFirst>myMinFrame) {
    myFirst=myLast-1;
    sliderFirst->setValue(myFirst);
    slotSliderFirstChanged(myFirst);
  }
  QString hilfe;
  hilfe.setNum(value);
  lineEditLast->setText( hilfe );
}
/** Is called, when the slieder ist moved */
void RangeOfFramesClass::slotSliderFirstChanged(int value){
  myFirst=value;
  if ( myFirst>=myLast && myLast<myMaxFrame ) {
    myLast=myFirst+1;
    sliderLast->setValue(myLast);
    slotSliderLastChanged(myLast);
  }
  QString hilfe;
  hilfe.setNum(value);
  lineEditFirst->setText( hilfe );
}/** If the textedit is changed */
void RangeOfFramesClass::slotChangeLast(const QString& value){
  myLast = value.toLong();
  if ( myLast > myMaxFrame ) {
    myLast = myMaxFrame;
  }
  slotShowFrames();
  slotSliderLastChanged(myLast);		
}
/** If the textedit is changed */
void RangeOfFramesClass::slotChangeFirst(const QString& value){
  myFirst = value.toLong();
  if ( myFirst < myMinFrame ) {
    myFirst = myMinFrame;
  }
  slotShowFrames();
  slotSliderFirstChanged(myFirst);
}
/** Is executed, when OK is pressed. */
void RangeOfFramesClass::slotOK(){
  myParent->slotSetFrameRange( checkBoxAll->isChecked(), myFirst, myLast);
  this->accept();
}
/** Sets the range values */
void RangeOfFramesClass::setRange( long start, long end){
  myFirst=start;
  myLast=end;
  slotShowFrames();
}
