/***************************************************************************
                          rangeofframesclass.h  -  description
                             -------------------
    begin                : Die Jun 3 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RANGEOFFRAMESCLASS_H
#define RANGEOFFRAMESCLASS_H
#include <klocale.h>
#include <qwidget.h>

#include "kavi2svcd.h"
#include "rangeofframesdlg.h"
/**
 *@author Cornelius Klbel
 */

class RangeOfFramesClass : public RangeOfFramesDlg  {
  Q_OBJECT
    public:
  RangeOfFramesClass(Kavi2svcd *parent=0, const char *name=0);
  ~RangeOfFramesClass();
  /** sets the maximum/minimum number of frames */
  void setMinMax(long min,long max);
  /** Sets the range values */
  void setRange( long start, long end);
 public: // Public attributes
  private slots: // Private slots
    /** Selects all Frames */
    void slotAll();
  /** Sets the gui depending on the frames */
  void slotShowFrames();
  /** Is called, when the slieder ist moved */
  void slotSliderLastChanged(int value);
  /** Is called, when the slider ist moved */
  void slotSliderFirstChanged(int value);
  /** If the textedit is changed */
  void slotChangeFirst(const QString& value);
  /** If the textedit is changed */
  void slotChangeLast(const QString& value);
  /** Is executed, when OK is pressed. */
  void slotOK();
 private: // Private attributes
  /**  */
  long myMinFrame;
  /**  */
  long myMaxFrame;
  /**  */
  long myFirst;
  /** The Parent */
  Kavi2svcd* myParent;
  /**  */
  long myLast;
};

#endif

