/***************************************************************************
                          scripteditclass.cpp  -  description
                             -------------------
    begin                : Mon Jul 29 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "scripteditclass.h"
#include "execscriptclass.h"

#include <qpushbutton.h>
#include <qtextedit.h>
#include <qmessagebox.h>
#include <qfiledialog.h>

ScriptEditClass::ScriptEditClass(GenerateScriptClass *parent, const char *name ) : ScriptEditDlg(0,name) {
  myParent=parent;
}
ScriptEditClass::~ScriptEditClass(){
}
/** Setzt den Text im Dialogfenster */
void ScriptEditClass::setText(QString text){
  TextEditScript->setText( text );
}
/** Setzt den Text als QStringlist im Editfenster */
void ScriptEditClass::setTextList(QStringList text){
  TextEditScript->setText( text.join("\n") );
}

/** Speichert das bisher editierte Script
    gendert: 06.08.2002
*/
void ScriptEditClass::slotSave(){
  QStringList script;
  QString test=TextEditScript->text();
  script = script.split("\n",test);
  myParent->setScript( script );
  myParent->saveScript(".");
  // Wenn das Script gespeichert ist, kann es auch ausgefhrt werden.
  PushButtonExec->show();
  PushButtonSave->hide();
}
/** Verzeichnis, in dem gespeichert wird */
void ScriptEditClass::setVerzeichnis(QString verz){
  myVerzeichnis=verz;
}
/** Fhrt das angezeigte Script aus.
    Neu: 06.08.2002
*/
void ScriptEditClass::slotExec(){
  ExecScriptClass* script = new ExecScriptClass();
  // Hier muss das temporre Script gespeichert werden.
  QString sTempScript;
  QString kdeHome=QString(getenv( "KDEHOME" ));
  if (kdeHome.isEmpty()) {
    sTempScript=QDir::homeDirPath();
    sTempScript.append("/.kde");
  } else {
    sTempScript=kdeHome;
  }
  sTempScript.append("/share/apps/kavi2svcd/tmp-script.sh");

  // Die routine zum speichern ist bereits in GenerateScriptClass enthalten.
  myParent->saving(sTempScript);
  // chmod 755
  QProcess* pChmod;
  pChmod = new QProcess();
  pChmod->addArgument("chmod");
  pChmod->addArgument("755");
  pChmod->addArgument(sTempScript);
  pChmod->start();
  delete pChmod;
  // Zeige den Dialog zum Ausfhren.
  script->setKommando( sTempScript );
  script->setMplexData( myParent->getVideo(),
			myParent->getAudio1(),
			myParent->getAudio2() );
  script->setVCDData( myParent->getCDsBrennen(), myParent->getPrefix() );
  script->exec();
  delete script;
}
/** Wird aufgerufen, wenn der Text im TExtedit sich gendert hat.
    Neu: 06.08.2002
*/
void ScriptEditClass::slotTextChanged(){
  PushButtonExec->hide();
  PushButtonSave->show();
}

/** Wird aufgerufen, wenn der Text unverndert ist. Wenn der Text mit der Variablen myScript bereinstimmt.
    Nach dem Laden in GenerateScriptClass::ViewScript()
    Neu: 06.08.2002
*/
void ScriptEditClass::slotTextFix(){
  PushButtonExec->show();
  PushButtonSave->hide();
}
