/***************************************************************************
                          scripteditclass.h  -  description
                             -------------------
    begin                : Mon Jul 29 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCRIPTEDITCLASS_H
#define SCRIPTEDITCLASS_H

#include "scripteditDlg.h"
#include "generatescriptclass.h"

#include <stdlib.h>
#include <qwidget.h>
#include <qstringlist.h>

/**Dialog, in dem das erzeugte Script editiert werden kann.
   Das ist ein in der Luft hngender Modaler Dialog,
   der keinen Vater hat und der NUR von
   GenerateScriptClass aufgerufen werden soll!
   *@author Cornelius Klbel
   */

class ScriptEditClass : public ScriptEditDlg  {
  Q_OBJECT
    public: 
  ScriptEditClass(GenerateScriptClass *parent=0, const char *name=0);
  ~ScriptEditClass();
  /** Setzt den Text im Dialogfenster */
  void setText(QString text);
  /** Setzt den Text als QStringlist im Editfenster */
  void setTextList(QStringList text);
  /** Verzeichnis, in dem gespeichert wird */
  void setVerzeichnis(QString verz);
  private slots: // Private slots
    /** Speichert das bisher editierte Script */
    void slotSave();
 signals: // Signals
  /** Dieses Signal wird geworfen, wenn gespeichert werden soll.
      Das Speichern passiert dann in der Klasse GenerateScriptClass */

 private: // Private attributes
  /** Verzeichnis, in dem gespeichert wird */
  QString myVerzeichnis;
  /** Vater: myScript / GenratreScriptClass */
  GenerateScriptClass* myParent;
  public slots: // Public slots
    /** Wird aufgerufen, wenn der Text im TExtedit sich ge?dert hat. */
    void slotTextChanged();
  public slots: // Public slots
    /** Fhrt das angezeigte Script aus. */
    void slotExec();
  /** Wird aufgerufen, wenn der Text unverndert ist. Wenn der Text mit der Variablen myScript bereinstimmt.
      Nach dem Laden! */
  void slotTextFix();
};

#endif
