/***************************************************************************
                          subtitlerclass.h  -  description
                             -------------------
    begin                : Mon Sep 22 2003
    copyright            : (C) 2003 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SUBTITLERCLASS_H
#define SUBTITLERCLASS_H

#include <qwidget.h>
#include <subtitledlg.h>
#include <qprocess.h>

/**Dialog, where you can configure the subtitle
 *@author Cornelius Klbel
 */

class SubtitlerClass : public subtitleDlg  {
  Q_OBJECT
    public: 
  SubtitlerClass(QWidget *parent=0, const char *name=0);
  ~SubtitlerClass();
  struct SubtitleData {
    float fps;
    QString movieFile;
    QString path;
    QString subEdit;
    QString subView;
    int iOffset;
    int iFontFactor;
    QString subFile;
    bool bUseSub;
    bool bTranscodeMode;
  };
  /** Sets all the private data of the class */
  void setData(SubtitleData d);
  /** returns the part of the transcode command, that is responsible for subtitles */
  QString getCommand();
  /** Returns the data of the subtitler class */
  SubtitlerClass::SubtitleData getData();
  private slots: // Private slots
    /** Is called, when the slider is changed value = 10..10000 (.1 .. 100) */
    void slotFontChanged(int i);
  /** is called when the textEdit is chaned. THe slider has to be set. */
  void slotFontChanged(const QString& s);
  /** A fileDialog is opened and the subtitle can be chosen. */
  void slotOpenFile();
  /** The subtitle file can be edited with ksubeditor */
  void slotEditFile();
 private: // Private attributes
  /** internal data */
  SubtitleData myData;
  /** Process for editing subtitles */
  QProcess* myEditProc;
  /** Process for previewing subtitles */
  QProcess* myPreviewProc;
  /** If the Button "check file" is pressed, this slot is called. Then mplayer is started with the subtitle. */
  void slotCheckFile();
};

#endif
