/***************************************************************************
                          transcode.h  -  description
                             -------------------
    begin                : Mit Jul 24 2002
    copyright            : (C) 2002 by Cornelius K�bel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRANSCODE_H
#define TRANSCODE_H

#include <klocale.h>
#include <qwidget.h>
#include <qprocess.h>

#include "procbaseclass.h"
#include "getinfoclass.h"

/**Das ist die Klasse, in der der Prozess zum transcoding aufgerufen wird.
 *@author Cornelius K�bel
 */

class Transcode : public ProcBaseClass  {
  Q_OBJECT
    public: 
  Transcode(QWidget *parent=0, const char *name=0);
  ~Transcode();
  /* Frames transcodierten Filems berechnet wird. */
  void setFrames(long lframes);
  /** Setzt die Videodadtei */
  void setVideoOut(QString video);
  /** Setzt den MPlayer */
  void setPlayer(QString player);
  /** Sets the basename of the files */
  void setDirModeFile(QString s);
  /** Sets the DirMode */
  void setDirMode(bool b);
 private: // Private attributes
  /** Anzahl der Frames des Filmes */
  long myFrames;
  /** VideoPreview */
  QString myPlayer;
  /** Videoausgabedatei */
  QString myVideoOut;
  /** If the directory mode will be used */
  bool myDirMode;
  /** The base name of all the files in Dirmode */
  QString myDirModeFile;
  /** For Directory Mode: This is the number of the file, beeing processed */
  int myNumFile;
  /** Class for getting information about an avifile */
  GetInfoClass* myGetInfo;
  /** For Directory mode: Total number of all files in directory */
  int myTotalFiles;
  /** Process for the preview */
  QProcess* myPreviewProc;

  private slots: // Private slots
    /** Liest die Ausgabe des Transcode-Prozesses aus. */
    void slotReadFromStdout(KProcess * proc, char * buffer, int buflen);
    void slotReadFromStderr(KProcess * proc, char * buffer, int buflen);
  /** Gets the number of frames. */
  void slotFrames(QString f);
  public slots: // Public slots
    /** Zeigt den bisher transkodierten Film */
    void slotPreview();
  /** Startet den Transcode-Prozess. */
  void slotStart(bool autoClose);
  protected slots: // Protected slots
    /** ?erladen der Funktion 
	ProcBaseClass::slotCancel() */
    void slotCancel();
};

#endif
