/***************************************************************************
                          vcdclass.h  -  description
                             -------------------
    begin                : Fre Jul 26 2002
    copyright            : (C) 2002 by Cornelius Klbel
    email                : cornelius.koelbel@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VCDCLASS_H
#define VCDCLASS_H

#include <klocale.h>
#include <qwidget.h>
#include "procbaseclass.h"
#include <qprocess.h>
#include <qtimer.h>

/**
 *@author Cornelius Klbel
 */

class VCDclass : public ProcBaseClass  {
  Q_OBJECT
    public: 
  VCDclass(QWidget *parent=0, const char *name=0);
  ~VCDclass();
  struct vcdData {
    int nice;
    QString additionalOption;
    QString type;
    QStringList fileList;
    QString cueFile;
    QString binFile;
    QString count;
    QString number;
    bool offset;
    bool broken;
    bool use2336;
    QString command;
  };
  /** berechnet den Progress vom VCD-Prozess */
  static int progress(QStringList sListe, QString myFilter, QString myPrefix, QString sBin, QString myPath);
  /** Set the data for calculating the progress */
  void setData(QString bin, QStringList liste);
  /** sets all the data from the GUI. This can be used to construct the command line */
  void setData(vcdData d);;
  /** Generates the command from the internal data structure */
  bool start();
  /** generates the Kommando for VCD from the vcdData. */
  QString generateKommando();
  /** Sets the current number and the total number */
  void setNum(int i, int t);

 private: // Private attributes
  /** Timer fr das Auswertern des Fortschritts */
  QTimer* myTimer;
  /** Liste der mpeg-Dateien, aus denen ein vcd erstellt werden soll */
  QStringList myMpegList;
  /** contains the data from the GUI */
  vcdData myData;
  /** bin-file, das erstellt werden soll. */
  QString myBin;
  private slots: // Public slots
    /** Wenn der Prozess zu Ende ist, wird der Timer angehalten. */
    void slotTimerStop();
  /** Wird nach einem bestimmten Zeitintervall aufgerufen, damit der Fortschritt geprft werden kann */
  void slotTimer();
};

#endif
